"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
This file is from triton-inference-server
https://github.com/triton-inference-server/server/blob/main/docs/protocol/extension_model_repository.md
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class RepositoryIndexRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REPOSITORY_NAME_FIELD_NUMBER: builtins.int
    READY_FIELD_NUMBER: builtins.int
    repository_name: builtins.str
    """The name of the repository. If empty the index is returned
    for all repositories.
    """
    ready: builtins.bool
    """If true return only models currently ready for inferencing."""
    def __init__(
        self,
        *,
        repository_name: builtins.str = ...,
        ready: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["ready", b"ready", "repository_name", b"repository_name"]) -> None: ...

global___RepositoryIndexRequest = RepositoryIndexRequest

@typing_extensions.final
class RepositoryIndexResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing_extensions.final
    class ModelIndex(google.protobuf.message.Message):
        """Index entry for a model."""

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        NAME_FIELD_NUMBER: builtins.int
        VERSION_FIELD_NUMBER: builtins.int
        STATE_FIELD_NUMBER: builtins.int
        REASON_FIELD_NUMBER: builtins.int
        name: builtins.str
        """The name of the model."""
        version: builtins.str
        """The version of the model."""
        state: builtins.str
        """The state of the model."""
        reason: builtins.str
        """The reason, if any, that the model is in the given state."""
        def __init__(
            self,
            *,
            name: builtins.str = ...,
            version: builtins.str = ...,
            state: builtins.str = ...,
            reason: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["name", b"name", "reason", b"reason", "state", b"state", "version", b"version"]) -> None: ...

    MODELS_FIELD_NUMBER: builtins.int
    @property
    def models(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___RepositoryIndexResponse.ModelIndex]:
        """An index entry for each model."""
    def __init__(
        self,
        *,
        models: collections.abc.Iterable[global___RepositoryIndexResponse.ModelIndex] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["models", b"models"]) -> None: ...

global___RepositoryIndexResponse = RepositoryIndexResponse

@typing_extensions.final
class RepositoryModelLoadRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REPOSITORY_NAME_FIELD_NUMBER: builtins.int
    MODEL_NAME_FIELD_NUMBER: builtins.int
    repository_name: builtins.str
    """The name of the repository to load from. If empty the model
    is loaded from any repository.
    """
    model_name: builtins.str
    """The name of the model to load, or reload."""
    def __init__(
        self,
        *,
        repository_name: builtins.str = ...,
        model_name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["model_name", b"model_name", "repository_name", b"repository_name"]) -> None: ...

global___RepositoryModelLoadRequest = RepositoryModelLoadRequest

@typing_extensions.final
class RepositoryModelLoadResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___RepositoryModelLoadResponse = RepositoryModelLoadResponse

@typing_extensions.final
class RepositoryModelUnloadRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    REPOSITORY_NAME_FIELD_NUMBER: builtins.int
    MODEL_NAME_FIELD_NUMBER: builtins.int
    repository_name: builtins.str
    """The name of the repository from which the model was originally
    loaded. If empty the repository is not considered.
    """
    model_name: builtins.str
    """The name of the model to unload."""
    def __init__(
        self,
        *,
        repository_name: builtins.str = ...,
        model_name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["model_name", b"model_name", "repository_name", b"repository_name"]) -> None: ...

global___RepositoryModelUnloadRequest = RepositoryModelUnloadRequest

@typing_extensions.final
class RepositoryModelUnloadResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___RepositoryModelUnloadResponse = RepositoryModelUnloadResponse
